"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs2/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createXhrProxy = createXhrProxy;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectWithoutProperties"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _xhrMock = _interopRequireDefault(require("xhr-mock"));

var mockDefaults = {
  method: 'get'
};

function createXhrProxy() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$fixtureKey = _ref.fixtureKey,
      fixtureKey = _ref$fixtureKey === void 0 ? 'xhr' : _ref$fixtureKey;

  var XhrProxy =
  /*#__PURE__*/
  function (_Component) {
    (0, _inherits2.default)(XhrProxy, _Component);

    function XhrProxy(props) {
      var _this;

      (0, _classCallCheck2.default)(this, XhrProxy);
      _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(XhrProxy).call(this, props)); // webpack shiz
      // $FlowFixMe

      if (module.hot) {
        module.hot.status(function (status) {
          if (status === 'check') {
            _xhrMock.default.teardown();
          }
        });
      }

      _this.mock();

      return _this;
    }

    (0, _createClass2.default)(XhrProxy, [{
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        // Make sure we don't clear a mock from a newer instance (in React 16
        // B.constructor is called before A.componentWillUnmount)
        if (_xhrMock.default.__prevProxy === this) {
          this.unmock();
        }
      }
    }, {
      key: "mock",
      value: function mock() {
        // Clear mocks from a previous FetchProxy instance
        // Warning: A page can only have one FetchProxy instance at the same time
        this.unmock();
        var mocks = this.props.fixture[fixtureKey];

        if (mocks) {
          _xhrMock.default.setup();

          mocks.forEach(function (options) {
            var _mockDefaults$options = (0, _objectSpread2.default)({}, mockDefaults, options),
                url = _mockDefaults$options.url,
                method = _mockDefaults$options.method,
                response = _mockDefaults$options.response;

            _xhrMock.default[method.toLowerCase()](url, response);
          });
          _xhrMock.default.__prevProxy = this;
        }
      }
    }, {
      key: "unmock",
      value: function unmock() {
        _xhrMock.default.teardown();
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
            nextProxy = _this$props.nextProxy,
            rest = (0, _objectWithoutProperties2.default)(_this$props, ["nextProxy"]);
        var NextProxy = nextProxy.value,
            next = nextProxy.next;
        return _react.default.createElement(NextProxy, (0, _extends2.default)({}, rest, {
          nextProxy: next()
        }));
      }
    }]);
    return XhrProxy;
  }(_react.Component);

  return XhrProxy;
}